--- groff-1.18.orig/src/devices/grotty/tty.cc
+++ groff-1.18/src/devices/grotty/tty.cc
@@ -20,6 +20,7 @@
 
 #include "driver.h"
 #include "device.h"
+#include "encoding.h"
 
 extern "C" const char *Version_string;
 
@@ -51,8 +52,21 @@
   HDRAW_MODE = 0x08,
   CU_MODE = 0x10,
   COLOR_CHANGE = 0x20
+#ifdef NIPPON
+  , WCHAR_MODE = 0x100
+#endif
 };
 
+#ifdef NIPPON
+# ifdef putchar
+#  undef putchar
+# endif
+inline void putchar(wchar wc)
+{
+  encoding->put_wchar(wc, stdout);
+}
+#endif
+
 // Mode to use for bold-underlining.
 static unsigned char bold_underline_mode = BOLD_MODE|UNDERLINE_MODE;
 
@@ -98,8 +112,26 @@
   }
   const char *num = f->get_internal_name();
   long n;
+#ifdef	NIPPON
+  if (num != 0) {
+    n = strtol(num, 0, 0);
+    switch (n) {
+    case 1:
+      f->mode = int(UNDERLINE_MODE);
+      break;
+    case 2:
+    case 5:
+      f->mode = int(BOLD_MODE);
+      break;
+    case 3:
+      f->mode = int(BOLD_MODE|UNDERLINE_MODE);
+      break;
+    }
+  }
+#else
   if (num != 0 && (n = strtol(num, 0, 0)) != 0)
     f->mode = int(n & (BOLD_MODE|UNDERLINE_MODE));
+#endif
   if (!underline_flag)
     f->mode &= ~UNDERLINE_MODE;
   if (!bold_flag)
@@ -242,8 +274,18 @@
 void tty_printer::make_underline()
 {
   if (old_drawing_scheme) {
+#if 0 /* def NIPPON XXX: not necessary? */
+    if ((p->mode & WCHAR_MODE)) {
+	putchar('_'); putchar('_');
+	putchar('\b'); putchar('\b');
+    } else {
+	putchar('_');
+	putchar('\b');
+    }
+#else
     putchar('_');
     putchar('\b');
+#endif
   }
   else {
     if (!is_underline) {
@@ -285,8 +327,10 @@
 void tty_printer::set_char(int i, font *f, const environment *env,
 			   int w, const char *name)
 {
+#ifndef NIPPON
   if (w != font::hor)
     fatal("width of character not equal to horizontal resolution");
+#endif
   add_char(f->get_code(i),
 	   env->hpos, env->vpos,
 	   env->col, env->fill,
@@ -338,6 +382,10 @@
   g->code = c;
   g->fore_color_idx = color_to_idx(fore);
   g->back_color_idx = color_to_idx(back);
+#ifdef NIPPON
+  if (encoding->is_wchar_code(c))
+    mode |= WCHAR_MODE;
+#endif
   g->mode = mode;
 
   // The list will be reversed later.  After reversal, it must be in
@@ -629,6 +677,11 @@
 	}
       }
       put_char(p->code);
+#ifdef	NIPPON
+      if (encoding->is_wchar_code(p->code))
+	hpos += 2;
+      else
+#endif
       hpos++;
     }
     if (!old_drawing_scheme
@@ -667,6 +720,7 @@
   if (getenv("GROFF_NO_SGR"))
     old_drawing_scheme = 1;
   setbuf(stderr, stderr_buf);
+  init_encoding_handler();
   int c;
   static const struct option long_options[] = {
     { "help", no_argument, 0, CHAR_MAX + 1 },
--- groff-1.18.orig/src/devices/grodvi/dvi.cc
+++ groff-1.18/src/devices/grodvi/dvi.cc
@@ -104,6 +104,9 @@
 struct output_font {
   dvi_font *f;
   int point_size;
+#ifdef	NIPPON
+  const char *sf;		// subfont name
+#endif
   output_font() : f(0) { }
 };
 
@@ -121,6 +124,9 @@
   output_font output_font_table[FONTS_MAX];
   font *cur_font;
   int cur_point_size;
+#ifdef NIPPON
+  const char *cur_subfont;
+#endif
   color cur_color;
   int pushed;
   int pushed_h;
@@ -341,9 +347,18 @@
   if (*env->col != cur_color)
     set_color(env->col);
   int code = f->get_code(index);
+#ifdef NIPPON
+  const char *sf = f->get_subfont_name(index);
+  if (env->size != cur_point_size || f != cur_font ||
+     (sf != cur_subfont && strcmp(sf, cur_subfont))) {
+#else
   if (env->size != cur_point_size || f != cur_font) {
+#endif
     cur_font = f;
     cur_point_size = env->size;
+#ifdef NIPPON
+    cur_subfont = sf;
+#endif
     int i;
     for (i = 0;; i++) {
       if (i >= FONTS_MAX) {
@@ -352,9 +367,16 @@
       if (output_font_table[i].f == 0) {
 	output_font_table[i].f = (dvi_font *)cur_font;
 	output_font_table[i].point_size = cur_point_size;
+#ifdef	NIPPON
+	output_font_table[i].sf = cur_subfont;
+#endif
 	define_font(i);
       }
       if (output_font_table[i].f == cur_font
+#ifdef	NIPPON
+	  && (output_font_table[i].sf == cur_subfont ||
+	      strcmp(output_font_table[i].sf, cur_subfont) == 0)
+#endif
 	  && output_font_table[i].point_size == cur_point_size)
 	break;
     }
@@ -398,7 +420,13 @@
   out4(f->checksum);
   out4(output_font_table[i].point_size*RES_7227);
   out4(int((double(f->design_size)/(1<<20))*RES_7227*100 + .5));
+#ifdef	NIPPON
+  const char *nm;
+  if (!(nm = output_font_table[i].sf))
+    nm = f->get_internal_name();
+#else
   const char *nm = f->get_internal_name();
+#endif
   out1(0);
   out_string(nm);
 }
@@ -889,6 +917,7 @@
   program_name = argv[0];
   static char stderr_buf[BUFSIZ];
   setbuf(stderr, stderr_buf);
+  init_encoding_handler();
   int c;
   static const struct option long_options[] = {
     { "help", no_argument, 0, CHAR_MAX + 1 },
--- groff-1.18.orig/src/devices/grohtml/html.h
+++ groff-1.18/src/devices/grohtml/html.h
@@ -49,6 +49,9 @@
 class simple_output {
 public:
   simple_output(FILE *, int max_line_length);
+#ifdef NIPPON
+  simple_output &put_string(const wchar *, int);
+#endif
   simple_output &put_string(const char *, int);
   simple_output &put_string(const char *s);
   simple_output &put_string(const string &s);
--- groff-1.18.orig/src/devices/grohtml/post-html.cc
+++ groff-1.18/src/devices/grohtml/post-html.cc
@@ -29,6 +29,7 @@
 #include "html.h"
 #include "html-text.h"
 #include "html-table.h"
+#include "encoding.h" // XXX: ukai
 
 #include <time.h>
 
@@ -314,6 +315,7 @@
   }
 
   old_used = tail->used;
+  /* XXX: encoding - ukai */
   do {
     tail->buffer[tail->used] = s[i];
     tail->used++;
@@ -2906,6 +2908,11 @@
   } else if (strcmp(fontname, "CR") == 0) {
     current_paragraph->done_tt();
   }
+#ifdef NIPPON
+  else if (strcmp(fontname, "G") == 0) {
+    current_paragraph->done_bold();
+  }
+#endif
 }
 
 /*
@@ -2931,6 +2938,15 @@
     }
     current_paragraph->do_tt();
   }
+#ifdef NIPPON
+  else if (strcmp(fontname, "M") == 0) {
+    current_paragraph->done_bold();
+    current_paragraph->done_italic();
+    current_paragraph->done_tt();
+  } else if (strcmp(fontname, "G") == 0) {
+    current_paragraph->do_bold();
+  }
+#endif
 }
 
 /*
@@ -3601,6 +3617,7 @@
   program_name = argv[0];
   static char stderr_buf[BUFSIZ];
   setbuf(stderr, stderr_buf);
+  init_encoding_handler();
   int c;
   static const struct option long_options[] = {
     { "help", no_argument, 0, CHAR_MAX + 1 },
--- groff-1.18.orig/src/xditview/Dvi.c
+++ groff-1.18/src/xditview/Dvi.c
@@ -49,6 +49,8 @@
 NBI	-adobe-new century schoolbook-bold-i-normal--*-100-*-*-*-*-iso8859-1\n\
 S	-adobe-symbol-medium-r-normal--*-100-*-*-*-*-adobe-fontspecific\n\
 SS	-adobe-symbol-medium-r-normal--*-100-*-*-*-*-adobe-fontspecific\n\
+M	-misc-fixed-medium-r-normal--*-100-*-*-*-*-jisx0208.1983-0\n\
+G	-misc-fixed-medium-r-normal--*-100-*-*-*-*-jisx0208.1983-0\
 ";
 
 #define offset(field) XtOffset(DviWidget, field)
--- groff-1.18.orig/src/xditview/DviChar.c
+++ groff-1.18/src/xditview/DviChar.c
@@ -6,6 +6,7 @@
  */
 
 #include   "DviChar.h"
+#include "encoding.h"
 
 extern char *xmalloc();
 
@@ -120,7 +121,16 @@
 {
 	int		i;
 	DviCharNameHash	*h;
+#if 0 /* def	NIPPON */
+	unsigned char ub = *name, lb = *(name + 1);
 
+	if (is_euc_byte(ub) && is_euc_byte(lb)) {
+	  int wc;
+	  wc = (name[0] & 0xff) << 8;
+	  wc |= (name[1] & 0xff);
+	  return(wc);
+	}
+#endif
 	i = hash_name (name) % DVI_HASH_SIZE;
 	for (h = map->buckets[i]; h; h=h->next)
 		if (!strcmp (h->name, name))
@@ -128,6 +138,15 @@
 	return -1;
 }
 
+#if 0 /* def	NIPPON */
+static DviCharNameMap JISX0208_1983_0_map = {
+	"jisx0208.1983-0",
+	0,
+{
+{	"DummyEntry",		/* 0 */},
+}};
+#endif
+
 static DviCharNameMap ISO8859_1_map = {
 	"iso8859-1",
 	0,
@@ -659,4 +678,7 @@
 	standard_maps_loaded = 1;
 	DviRegisterMap (&ISO8859_1_map);
 	DviRegisterMap (&Adobe_Symbol_map);
+#if 0 /* def	NIPPON */
+	DviRegisterMap (&JISX0208_1983_0_map);
+#endif
 }
--- groff-1.18.orig/src/xditview/DviP.h
+++ groff-1.18/src/xditview/DviP.h
@@ -89,9 +89,17 @@
 #define DVI_CHAR_CACHE_SIZE	1024
 
 typedef struct _dviCharCache {
+#if 0 /* def	NIPPON */
+	XTextItem16	cache[DVI_TEXT_CACHE_SIZE];
+#else
 	XTextItem	cache[DVI_TEXT_CACHE_SIZE];
+#endif
 	char		adjustable[DVI_TEXT_CACHE_SIZE];
+#if 0 /* def	NIPPON */
+	XChar2b		char_cache[DVI_CHAR_CACHE_SIZE];
+#else
 	char		char_cache[DVI_CHAR_CACHE_SIZE];
+#endif
 	int		index;
 	int		max;
 	int		char_index;
--- groff-1.18.orig/src/xditview/GXditview-ad.h
+++ groff-1.18/src/xditview/GXditview-ad.h
@@ -50,3 +50,24 @@
 "GXditview.promptShell.promptDialog.cancel.label: Cancel",
 "GXditview.promptShell.promptDialog.cancel.translations: #override \
 	<BtnUp>:	Cancel() unset()",
+"GXditview*fontMap: \
+TR	-adobe-times-medium-r-normal--*-100-*-*-*-*-iso8859-1\\n\
+TI	-adobe-times-medium-i-normal--*-100-*-*-*-*-iso8859-1\\n\
+TB	-adobe-times-bold-r-normal--*-100-*-*-*-*-iso8859-1\\n\
+TBI	-adobe-times-bold-i-normal--*-100-*-*-*-*-iso8859-1\\n\
+CR	-adobe-courier-medium-r-normal--*-100-*-*-*-*-iso8859-1\\n\
+CI	-adobe-courier-medium-o-normal--*-100-*-*-*-*-iso8859-1\\n\
+CB	-adobe-courier-bold-r-normal--*-100-*-*-*-*-iso8859-1\\n\
+CBI	-adobe-courier-bold-o-normal--*-100-*-*-*-*-iso8859-1\\n\
+HR	-adobe-helvetica-medium-r-normal--*-100-*-*-*-*-iso8859-1\\n\
+HI	-adobe-helvetica-medium-o-normal--*-100-*-*-*-*-iso8859-1\\n\
+HB	-adobe-helvetica-bold-r-normal--*-100-*-*-*-*-iso8859-1\\n\
+HBI	-adobe-helvetica-bold-o-normal--*-100-*-*-*-*-iso8859-1\\n\
+NR	-adobe-new century schoolbook-medium-r-normal--*-100-*-*-*-*-iso8859-1\\n\
+NI	-adobe-new century schoolbook-medium-i-normal--*-100-*-*-*-*-iso8859-1\\n\
+NB	-adobe-new century schoolbook-bold-r-normal--*-100-*-*-*-*-iso8859-1\\n\
+NBI	-adobe-new century schoolbook-bold-i-normal--*-100-*-*-*-*-iso8859-1\\n\
+S	-adobe-symbol-medium-r-normal--*-100-*-*-*-*-adobe-fontspecific\\n\
+SS	-adobe-symbol-medium-r-normal--*-100-*-*-*-*-adobe-fontspecific\\n\
+M	-misc-fixed-medium-r-normal--*-100-*-*-*-*-jisx0208.1983-0\\n\
+G	-misc-fixed-medium-r-normal--*-100-*-*-*-*-jisx0208.1983-0",
--- groff-1.18.orig/src/xditview/GXditview.ad
+++ groff-1.18/src/xditview/GXditview.ad
@@ -55,3 +55,25 @@
 GXditview.promptShell.promptDialog.cancel.label: Cancel
 GXditview.promptShell.promptDialog.cancel.translations: #override \
 	<BtnUp>:	Cancel() unset()
+
+GXditview*fontMap: \
+TR	-adobe-times-medium-r-normal--*-100-*-*-*-*-iso8859-1\n\
+TI	-adobe-times-medium-i-normal--*-100-*-*-*-*-iso8859-1\n\
+TB	-adobe-times-bold-r-normal--*-100-*-*-*-*-iso8859-1\n\
+TBI	-adobe-times-bold-i-normal--*-100-*-*-*-*-iso8859-1\n\
+CR	-adobe-courier-medium-r-normal--*-100-*-*-*-*-iso8859-1\n\
+CI	-adobe-courier-medium-o-normal--*-100-*-*-*-*-iso8859-1\n\
+CB	-adobe-courier-bold-r-normal--*-100-*-*-*-*-iso8859-1\n\
+CBI	-adobe-courier-bold-o-normal--*-100-*-*-*-*-iso8859-1\n\
+HR	-adobe-helvetica-medium-r-normal--*-100-*-*-*-*-iso8859-1\n\
+HI	-adobe-helvetica-medium-o-normal--*-100-*-*-*-*-iso8859-1\n\
+HB	-adobe-helvetica-bold-r-normal--*-100-*-*-*-*-iso8859-1\n\
+HBI	-adobe-helvetica-bold-o-normal--*-100-*-*-*-*-iso8859-1\n\
+NR	-adobe-new century schoolbook-medium-r-normal--*-100-*-*-*-*-iso8859-1\n\
+NI	-adobe-new century schoolbook-medium-i-normal--*-100-*-*-*-*-iso8859-1\n\
+NB	-adobe-new century schoolbook-bold-r-normal--*-100-*-*-*-*-iso8859-1\n\
+NBI	-adobe-new century schoolbook-bold-i-normal--*-100-*-*-*-*-iso8859-1\n\
+S	-adobe-symbol-medium-r-normal--*-100-*-*-*-*-adobe-fontspecific\n\
+SS	-adobe-symbol-medium-r-normal--*-100-*-*-*-*-adobe-fontspecific\n\
+M	-misc-fixed-medium-r-normal--*-100-*-*-*-*-jisx0208.1983-0\n\
+G	-misc-fixed-medium-r-normal--*-100-*-*-*-*-jisx0208.1983-0
--- groff-1.18.orig/src/xditview/draw.c
+++ groff-1.18/src/xditview/draw.c
@@ -17,6 +17,7 @@
 #endif
 
 #include "DviP.h"
+#include "encoding.h" /* XXX */
 
 #define DeviceToX(dw, n) ((int)((n) * (dw)->dvi.scale_factor + .5))
 #define XPos(dw) (DeviceToX((dw), (dw)->dvi.state->x - \
@@ -99,9 +100,15 @@
 {
 	if (dw->dvi.cache.char_index != 0) {
 		AdjustCacheDeltas (dw);
+#if 0 /* def	NIPPON */
+		XDrawText16 (XtDisplay (dw), XtWindow (dw), dw->dvi.normal_GC,
+			   dw->dvi.cache.start_x, dw->dvi.cache.start_y,
+			   dw->dvi.cache.cache, dw->dvi.cache.index + 1);
+#else
 		XDrawText (XtDisplay (dw), XtWindow (dw), dw->dvi.normal_GC,
 			   dw->dvi.cache.start_x, dw->dvi.cache.start_y,
 			   dw->dvi.cache.cache, dw->dvi.cache.index + 1);
+#endif
 	}	
 	dw->dvi.cache.index = 0;
 	dw->dvi.cache.max = DVI_TEXT_CACHE_SIZE;
@@ -129,12 +136,27 @@
 	dw->dvi.word_flag = 1;
 }
 
+#if 0 /* def	NIPPON */
+int charWidth(fi, c)
+XFontStruct *fi;
+int	c;
+{
+	if (is_euc_code(c)) {
+		return fi->max_bounds.width;
+	} else {
+		return fi->per_char ?
+			fi->per_char[c - fi->min_char_or_byte2].width :
+			fi->max_bounds.width;
+	}
+}
+#else
 #define charWidth(fi,c) (\
     (fi)->per_char ?\
 	(fi)->per_char[(c) - (fi)->min_char_or_byte2].width\
     :\
 	(fi)->max_bounds.width\
 )
+#endif /* NIPPON */
  
 
 static
@@ -144,6 +166,10 @@
 {
 	XCharStruct *p;
 
+#if 0 /* def	NIPPON */
+	if (is_euc_code(c))
+		return 1;	/* Neglect ;-P */
+#endif
 	if (fi->per_char == NULL ||
 	    c < fi->min_char_or_byte2 || c > fi->max_char_or_byte2)
 		return 0;
@@ -159,7 +185,11 @@
 	int wid;    /* width in device units */
 {
 	register XFontStruct	*font;
+#if 0 /* def	NIPPON */
+	register XTextItem16	*text;
+#else
 	register XTextItem	*text;
+#endif
 	int	x, y;
 	
 	x = XPos(dw);
@@ -227,7 +257,21 @@
 	}
 	if (charExists(font, c)) {
 		int w;
+#if 0 /* def	NIPPON */
+		if (is_euc_code(c)) {
+			dw->dvi.cache.char_cache[dw->dvi.cache.char_index].
+				byte1 =	(unsigned char)jis_ubyte(c);
+			dw->dvi.cache.char_cache[dw->dvi.cache.char_index++].
+				byte2 =	(unsigned char)jis_lbyte(c);
+		} else {
+			dw->dvi.cache.char_cache[dw->dvi.cache.char_index].
+				byte1 =	(unsigned char)'\0';
+			dw->dvi.cache.char_cache[dw->dvi.cache.char_index++].
+				byte2 =	(unsigned char)c;
+		}
+#else
 		dw->dvi.cache.char_cache[dw->dvi.cache.char_index++] = (char) c;
+#endif
 		++text->nchars;
 		w = charWidth(font, c);
 		dw->dvi.cache.x += w;
--- groff-1.18.orig/src/xditview/parse.c
+++ groff-1.18/src/xditview/parse.c
@@ -10,6 +10,7 @@
 #include <stdio.h>
 #include <ctype.h>
 #include "DviP.h"
+#include "encoding.h"
 
 static int StopSeen = 0;
 static ParseDrawFunction(), ParseDeviceControl();
@@ -62,6 +63,13 @@
 			    break;
 			Buffer[0] = c;
 			Buffer[1] = '\0';
+#if 0 /* def	NIPPON */
+			if (is_euc_byte(c)) {
+				DviGetC(dw,&c);
+				Buffer[1] = c;
+				Buffer[2] = '\0';
+			}
+#endif
 			(void) PutCharacter (dw, Buffer);
 			break;
 		case 'C':
@@ -73,6 +81,13 @@
 			while (DviGetC (dw, &c) != EOF
 			       && c != ' ' && c != '\n') {
 				Buffer[0] = c;
+#if 0 /* def	NIPPON */
+				if (is_euc_byte(c)) {
+					DviGetC(dw,&c);
+					Buffer[1] = c;
+					Buffer[2] = '\0';
+				}
+#endif
 				HorizontalMove (dw, PutCharacter (dw, Buffer));
 			}
 			break;
--- groff-1.18.orig/src/xditview/xtotroff.c
+++ groff-1.18/src/xditview/xtotroff.c
@@ -171,6 +171,47 @@
 			fprintf (out, "spacewidth %d\n", w);
 	}
 	fprintf (out, "charset\n");
+#if 0 /* def	NIPPON */
+	if (fi->min_byte1 != 0 || fi->max_byte1 != 0) {
+		/*
+		 * 2 byte code font.
+		 */
+		int N;
+		int D = fi->max_char_or_byte2 -	fi->min_char_or_byte2 + 1;
+		int max = (fi->max_byte1 - fi->min_byte1 + 1) *
+			(fi->max_char_or_byte2 - fi->min_char_or_byte2 + 1);
+		unsigned byte1;
+		unsigned byte2;
+		unsigned int euc_code;
+
+		for (N = 0; N < max; N++) {
+			byte1 = N / D + fi->min_byte1;
+			byte2 = N % D + fi->min_char_or_byte2;
+			euc_code = ((byte1 << 8) | byte2) & 0xffff | 0x8080;
+			wid = fi->max_bounds.width;
+			fputc(byte1 & 0xff | 0x80, out);/* output EUC code */
+			fputc(byte2 & 0xff | 0x80, out);/* output EUC code */
+			fprintf (out, "\t%d", wid);
+			if (groff_flag) {
+				int	param[5];
+				param[0] = fi->max_bounds.ascent;
+				param[1] = fi->max_bounds.descent;
+				param[2] = 0 /* charRBearing (fi, c) - wid */;
+				param[3] = 0 /* charLBearing (fi, c) */;
+				param[4] = 0; /* XXX */
+				for (j = 0; j < 5; j++)
+					if (param[j] < 0)
+						param[j] = 0;
+				for (j = 4; j >= 0; j--)
+					if (param[j] != 0)
+						break;
+				for (k = 0; k <= j; k++)
+					fprintf (out, ",%d", param[k]);
+			}
+			fprintf (out, "\t0\t%#x\n", euc_code);
+		}
+	} else
+#endif /* NIPPON */
 	for (c = fi->min_char_or_byte2; c <= fi->max_char_or_byte2; c++) {
 		char *name = DviCharName (char_map,c,0);
 		if (charExists (fi, c) && (groff_flag || name)) {
--- groff-1.18.orig/src/xditview/FontMap.jisx0208
+++ groff-1.18/src/xditview/FontMap.jisx0208
@@ -0,0 +1,2 @@
+M	-misc-fixed-medium-r-normal--*-100-*-*-*-*-jisx0208.1983-0
+G	-misc-fixed-medium-r-normal--*-100-*-*-*-*-jisx0208.1983-0
--- groff-1.18.orig/src/xditview/encoding.h
+++ groff-1.18/src/xditview/encoding.h
@@ -0,0 +1,37 @@
+// -*- C++ -*-
+/* Copyright (c) 2001 Fumitoshi UKAI <ukai@debian.or.jp>
+
+This file is part of groff.
+
+groff is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 2, or (at your option) any later
+version.
+
+groff is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+
+#ifndef ENCODING_H
+#define ENCODING_H
+
+#ifdef NIPPON
+typedef unsigned int wchar;
+#else
+typedef char wchar;
+#endif
+
+#if 0
+#define EUCMASK	0x8080
+#define is_euc_code(c)	(((c) & EUCMASK) == EUCMASK)
+#define is_euc_byte(c)  ((c) >= 0xa1 && (c) <= 0xfe)
+#define jis_ubyte(wc)	(((wc) >> 8) & 0x7f)
+#define jis_lbyte(wc)	((wc) & 0x7f)
+#endif	/* 0 */
+
+#endif
--- groff-1.18.orig/src/xditview/eucmac.h
+++ groff-1.18/src/xditview/eucmac.h
@@ -0,0 +1,14 @@
+/* 
+ * eucmac.h - japanese enhancement support module.
+ */
+
+#ifndef _EUCMAC_H
+#define _EUCMAC_H
+
+#define EUCMASK	0x8080
+#define is_euc_code(c)	(((c) & EUCMASK) == EUCMASK)
+#define is_euc_byte(c)  ((c) >= 0xa1 && (c) <= 0xfe)
+#define jis_ubyte(wc)	(((wc) >> 8) & 0x7f)
+#define jis_lbyte(wc)	((wc) & 0x7f)
+
+#endif	/* _EUCMAC_H */
--- groff-1.18.orig/font/devps/DESC.in
+++ groff-1.18/font/devps/DESC.in
@@ -1,11 +1,14 @@
 res 72000
 hor 1
 vert 1
+lowerwchar 300
+wcharkern 400
 sizescale 1000
 unitwidth 1000
 sizes 1000-10000000 0
 styles R I B BI
 family T
-fonts 9 0 0 0 0 0 SS S ZD ZDR
+fonts 11 0 0 0 0 0 SS S ZD ZDR M G
+ondemand M G
 tcommand
 postpro grops
--- groff-1.18.orig/font/devps/Makefile.sub
+++ groff-1.18/font/devps/Makefile.sub
@@ -2,23 +2,23 @@
 DISTFILES=text.enc download \
   S ZD ZDR SS AB ABI AI AR BMB BMBI BMI BMR \
   CB CBI CI CR HB HBI HI HR HNB HNBI HNI HNR \
-  NB NBI NI NR PB PBI PI PR TB TBI TI TR ZCMI
+  NB NBI NI NR PB PBI PI PR TB TBI TI TR ZCMI M G
 PSFILES=prologue symbolsl.pfa zapfdr.pfa
 DEVGENFILES=generate/Makefile generate/afmname generate/dingbats.map \
   generate/dingbats.rmap generate/lgreekmap generate/symbol.sed \
   generate/symbolchars generate/symbolsl.afm generate/textmap
 DEVFILES=DESC $(PSFILES) $(DISTFILES) $(DEVGENFILES)
 
-CLEANADD=DESC $(PSFILES)
+CLEANADD=DESC $(PSFILES) M G
 
 DESC: DESC.in
 	-rm -f DESC
 	cat $(srcdir)/DESC.in >DESC
 	echo broken $(BROKEN_SPOOLER_FLAGS) >>DESC
 	if test "$(PAGE)" = A4; then \
-	  echo "papersize a4" >>DESC; \
+	  echo "papersize /etc/papersize a4" >>DESC; \
 	else \
-	  echo "papersize letter" >>DESC; \
+	  echo "papersize /etc/papersize letter" >>DESC; \
 	fi
 	test -z '$(PSPRINT)' ||	echo print '$(PSPRINT)' >>DESC
 
@@ -33,3 +33,14 @@
 $(PSFILES):
 	-rm -f $@
 	sed -f $(srcdir)/psstrip.sed $? >$@
+
+M: M.header
+	@echo Making M
+	@-rm -f M
+	@(cat $(srcdir)/M.header; echo charset) > M
+
+G: M
+	@echo Making G
+	@-rm -f G
+	@sed -e 's/name M/name G/' \
+	    -e 's/internalname Ryumin-Light-EUC-H/internalname GothicBBB-Medium-EUC-H/' M > G
--- groff-1.18.orig/font/devps/M.header
+++ groff-1.18/font/devps/M.header
@@ -0,0 +1,4 @@
+name M
+internalname Ryumin-Light-EUC-H
+spacewidth 1000
+fixedkanji 1000,880,120 3
--- groff-1.18.orig/font/devdvi/FixMetric.sed
+++ groff-1.18/font/devdvi/FixMetric.sed
@@ -0,0 +1,77 @@
+s/1006514,.*0x212b$/370845,815360,145600	1	0x212b/
+s/1006514,.*0x212c$/370845,815360,145600	1	0x212c/
+s/1006514,.*0x2126$/370845,815360,145600	1	0x2126/
+s/1006514,.*0x2127$/370845,815360,145600	1	0x2127/
+s/1006514,.*0x2128$/370845,815360,145600	1	0x2128/
+s/1006514,.*0x212a$/370845,815360,145600	1	0x212a/
+s/1006514,.*0x212d$/370845,815360,145600	1	0x212d/
+s/1006514,.*0x212e$/370845,815360,145600	1	0x212e/
+s/1006514,.*0x213e$/370845,815360,145600	1	0x213e/
+s/1006514,.*0x2142$/370845,815360,145600	1	0x2142/
+s/1006514,.*0x2143$/370845,815360,145600	1	0x2143/
+s/1006514,.*0x2146$/370845,815360,145600	1	0x2146/
+s/1006514,.*0x2147$/370845,815360,145600	1	0x2147/
+s/1006514,.*0x2124$/370845,815360,145600	1	0x2124/
+s/1006514,.*0x2125$/370845,815360,145600	1	0x2125/
+s/1006514,.*0x214b$/528496,815360,145600	1	0x214b/
+s/1006514,.*0x214d$/528496,815360,145600	1	0x214d/
+s/1006514,.*0x214f$/528496,815360,145600	1	0x214f/
+s/1006514,.*0x2151$/528496,815360,145600	1	0x2151/
+s/1006514,.*0x2153$/528496,815360,145600	1	0x2153/
+s/1006514,.*0x2155$/528496,815360,145600	1	0x2155/
+s/1006514,.*0x2157$/528496,815360,145600	1	0x2157/
+s/1006514,.*0x2159$/528496,815360,145600	1	0x2159/
+s/1006514,.*0x215b$/528496,815360,145600	1	0x215b/
+s/1006514,.*0x2129$/528496,815360,145600	1	0x2129/
+s/1006514,.*0x212f$/528496,815360,145600	1	0x212f/
+s/1006514,.*0x2130$/528496,815360,145600	1	0x2130/
+s/1006514,.*0x2133$/528496,815360,145600	1	0x2133/
+s/1006514,.*0x2135$/528496,815360,145600	1	0x2135/
+s/1006514,.*0x2148$/528496,815360,145600	1	0x2148/
+s/1006514,.*0x2149$/528496,815360,145600	1	0x2149/
+s/1006514,.*0x216b$/528496,815360,145600	1	0x216b/
+s/1006514,.*0x216c$/528496,815360,145600	1	0x216c/
+s/1006514,.*0x216d$/528496,815360,145600	1	0x216d/
+s/1006514,.*0x2178$/528496,815360,145600	1	0x2178/
+s/1006514,.*0x214a$/528496,815360,145600	1	0x214a/
+s/1006514,.*0x214c$/528496,815360,145600	1	0x214c/
+s/1006514,.*0x214e$/528496,815360,145600	1	0x214e/
+s/1006514,.*0x2150$/528496,815360,145600	1	0x2150/
+s/1006514,.*0x2152$/528496,815360,145600	1	0x2152/
+s/1006514,.*0x2154$/528496,815360,145600	1	0x2154/
+s/1006514,.*0x2156$/528496,815360,145600	1	0x2156/
+s/1006514,.*0x2158$/528496,815360,145600	1	0x2158/
+s/1006514,.*0x215a$/528496,815360,145600	1	0x215a/
+s/1006514,.*0x2122$/528496,815360,145600	1	0x2122/
+s/1006514,.*0x2123$/528496,815360,145600	1	0x2123/
+s/1006514,.*0x2136$/783741,815360,145600	1	0x2136/
+s/1006514,.*0x2137$/783741,815360,145600	1	0x2137/
+s/1006514,.*0x2139$/783741,815360,145600	1	0x2139/
+s/1006514,.*0x2168$/783741,815360,145600	1	0x2168/
+s/1006514,.*0x2169$/783741,815360,145600	1	0x2169/
+s/1006514,.*0x216a$/783741,815360,145600	1	0x216a/
+s/1006514,.*0x2170$/783741,815360,145600	1	0x2170/
+s/1006514,.*0x2171$/783741,815360,145600	1	0x2171/
+s/1006514,.*0x2172$/783741,815360,145600	1	0x2172/
+s/1006514,.*0x2421$/783741,815360,145600	1	0x2421/
+s/1006514,.*0x2423$/783741,815360,145600	1	0x2423/
+s/1006514,.*0x2425$/783741,815360,145600	1	0x2425/
+s/1006514,.*0x2427$/783741,815360,145600	1	0x2427/
+s/1006514,.*0x2429$/783741,815360,145600	1	0x2429/
+s/1006514,.*0x2443$/783741,815360,145600	1	0x2443/
+s/1006514,.*0x2463$/783741,815360,145600	1	0x2463/
+s/1006514,.*0x2465$/783741,815360,145600	1	0x2465/
+s/1006514,.*0x2467$/783741,815360,145600	1	0x2467/
+s/1006514,.*0x246e$/783741,815360,145600	1	0x246e/
+s/1006514,.*0x2521$/783741,815360,145600	1	0x2521/
+s/1006514,.*0x2523$/783741,815360,145600	1	0x2523/
+s/1006514,.*0x2525$/783741,815360,145600	1	0x2525/
+s/1006514,.*0x2527$/783741,815360,145600	1	0x2527/
+s/1006514,.*0x2529$/783741,815360,145600	1	0x2529/
+s/1006514,.*0x2543$/783741,815360,145600	1	0x2543/
+s/1006514,.*0x2563$/783741,815360,145600	1	0x2563/
+s/1006514,.*0x2565$/783741,815360,145600	1	0x2565/
+s/1006514,.*0x2567$/783741,815360,145600	1	0x2567/
+s/1006514,.*0x256e$/783741,815360,145600	1	0x256e/
+s/1006514,.*0x2575$/783741,815360,145600	1	0x2575/
+s/1006514,.*0x2576$/783741,815360,145600	1	0x2576/
--- groff-1.18.orig/font/devdvi/M.proto-ASCII
+++ groff-1.18/font/devdvi/M.proto-ASCII
@@ -0,0 +1,4 @@
+name M
+internalname min10
+checksum -375402250
+designsize 10485760
